/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'minimips.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.instruction.IOperation;
import ru.ispras.microtesk.model.api.instruction.Operation;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.IAddressingMode;
import ru.ispras.microtesk.model.minimips.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.minimips.shared.Shared.*;

public final class bgezal extends Operation {
  private static final class Info extends InfoAndRule {
    Info()
    {
        super(
           bgezal.class,
           "bgezal",
           false,
           new ParamDecls()
               .declareParam("rs", ArgumentMode.IN, REG.INFO)
               .declareParam("offset", SHORT),
           new Shortcuts()
               .addShortcut(new Info_instruction(), "#root")
        );
    }

    @Override
    public IOperation create(Map<String, Object> args)
    {
        final IAddressingMode rs = (IAddressingMode) getArgument("rs", args);
        final Location offset = (Location) getArgument("offset", args);

        return new bgezal(rs, offset);
    }
  }

  private static final class Info_instruction extends InfoAndRule {
    Info_instruction()
    {
        super(
            instruction.class,
            "bgezal",
            true,
            new ParamDecls()
                .declareParam("rs", ArgumentMode.IN, REG.INFO)
                .declareParam("offset", SHORT)
        );
    }

    @Override
    public IOperation create(Map<String, Object> args)
    {
        final IAddressingMode rs = (IAddressingMode) getArgument("rs", args);
        final Location offset = (Location) getArgument("offset", args);

        return new instruction(
            new bgezal(
                rs,
                offset
            )
        );
    }
  }

  public static final IInfo INFO = new Info();

  private final IAddressingMode rs;
  private final Location offset;

  public bgezal(IAddressingMode rs, Location offset)
  {
      assert REG.INFO.isSupported(rs);
      assert SHORT.equals(offset.getType());

      this.rs = rs;
      this.offset = offset;
  }

  @Override
  public String syntax()
  {
      return String.format("bgezal %s, <label>%d", rs.syntax(), offset.load().getRawData().intValue());
  }

  @Override
  public String image()
  {
      return String.format("000001%s10001%s", rs.image(), offset.load().getRawData().toString());
  }

  @Override
  public void action()
  {
      if (DataEngine.intValue(rs.access().load()) >= 0x0)
      {
          GPR.access(0x1f).store(DataEngine.execute(EOperatorID.PLUS, DataEngine.execute(EOperatorID.PLUS, CIA.access().load(), DataEngine.valueOf(WORD, 0x4)), DataEngine.valueOf(WORD, 0x4)));
          BRANCH.access().store(DataEngine.valueOf(Type.INT(0x1), 1));
          JMPADDR.access().store(DataEngine.execute(EOperatorID.PLUS, DataEngine.execute(EOperatorID.PLUS, CIA.access().load(), DataEngine.coerce(WORD, DataEngine.execute(EOperatorID.MUL, DataEngine.valueOf(SHORT, 0x4), offset.load()))), DataEngine.valueOf(WORD, 0x4)));
      }
  }
}
