/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'minimips.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.instruction.IOperation;
import ru.ispras.microtesk.model.api.instruction.Operation;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.IAddressingMode;
import ru.ispras.microtesk.model.minimips.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.minimips.shared.Shared.*;

public final class bltz extends Operation {
  private static final class Info extends InfoAndRule {
    Info()
    {
        super(
           bltz.class,
           "bltz",
           false,
           new ParamDecls()
               .declareParam("rs", ArgumentMode.IN, REG.INFO)
               .declareParam("imm", SHORT),
           new Shortcuts()
               .addShortcut(new Info_instruction(), "#root")
        );
    }

    @Override
    public IOperation create(Map<String, Object> args)
    {
        final IAddressingMode rs = (IAddressingMode) getArgument("rs", args);
        final Location imm = (Location) getArgument("imm", args);

        return new bltz(rs, imm);
    }
  }

  private static final class Info_instruction extends InfoAndRule {
    Info_instruction()
    {
        super(
            instruction.class,
            "bltz",
            true,
            new ParamDecls()
                .declareParam("rs", ArgumentMode.IN, REG.INFO)
                .declareParam("imm", SHORT)
        );
    }

    @Override
    public IOperation create(Map<String, Object> args)
    {
        final IAddressingMode rs = (IAddressingMode) getArgument("rs", args);
        final Location imm = (Location) getArgument("imm", args);

        return new instruction(
            new bltz(
                rs,
                imm
            )
        );
    }
  }

  public static final IInfo INFO = new Info();

  private final IAddressingMode rs;
  private final Location imm;

  public bltz(IAddressingMode rs, Location imm)
  {
      assert REG.INFO.isSupported(rs);
      assert SHORT.equals(imm.getType());

      this.rs = rs;
      this.imm = imm;
  }

  @Override
  public String syntax()
  {
      return String.format("bltz %s, <label>%d", rs.syntax(), imm.load().getRawData().intValue());
  }

  @Override
  public String image()
  {
      return String.format("000001%s00000%s", rs.image(), imm.load().getRawData().toString());
  }

  @Override
  public void action()
  {
      if (DataEngine.intValue(rs.access().load()) < 0x0)
      {
          BRANCH.access().store(DataEngine.valueOf(Type.INT(0x1), 1));
          JMPADDR.access().store(DataEngine.execute(EOperatorID.PLUS, DataEngine.execute(EOperatorID.PLUS, CIA.access().load(), DataEngine.coerce(WORD, DataEngine.execute(EOperatorID.MUL, DataEngine.valueOf(SHORT, 0x4), imm.load()))), DataEngine.valueOf(WORD, 0x4)));
      }
  }
}
