/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'minimips.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.instruction.IOperation;
import ru.ispras.microtesk.model.api.instruction.Operation;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.IAddressingMode;
import ru.ispras.microtesk.model.minimips.mode.*;

import static ru.ispras.microtesk.model.minimips.shared.Shared.*;

public final class jalr extends Operation {
  private static final class Info extends InfoAndRule {
    Info()
    {
        super(
           jalr.class,
           "jalr",
           false,
           new ParamDecls()
               .declareParam("rd", ArgumentMode.OUT, REG.INFO)
               .declareParam("rs", ArgumentMode.IN, REG.INFO),
           new Shortcuts()
               .addShortcut(new Info_instruction(), "#root")
        );
    }

    @Override
    public IOperation create(Map<String, Object> args)
    {
        final IAddressingMode rd = (IAddressingMode) getArgument("rd", args);
        final IAddressingMode rs = (IAddressingMode) getArgument("rs", args);

        return new jalr(rd, rs);
    }
  }

  private static final class Info_instruction extends InfoAndRule {
    Info_instruction()
    {
        super(
            instruction.class,
            "jalr",
            true,
            new ParamDecls()
                .declareParam("rd", ArgumentMode.OUT, REG.INFO)
                .declareParam("rs", ArgumentMode.IN, REG.INFO)
        );
    }

    @Override
    public IOperation create(Map<String, Object> args)
    {
        final IAddressingMode rd = (IAddressingMode) getArgument("rd", args);
        final IAddressingMode rs = (IAddressingMode) getArgument("rs", args);

        return new instruction(
            new jalr(
                rd,
                rs
            )
        );
    }
  }

  public static final IInfo INFO = new Info();

  private final IAddressingMode rd;
  private final IAddressingMode rs;

  public jalr(IAddressingMode rd, IAddressingMode rs)
  {
      assert REG.INFO.isSupported(rd);
      assert REG.INFO.isSupported(rs);

      this.rd = rd;
      this.rs = rs;
  }

  @Override
  public String syntax()
  {
      return String.format("jalr %s, %s", rs.syntax(), rd.syntax());
  }

  @Override
  public String image()
  {
      return String.format("000000%s00000%s00000001001", rs.image(), rd.image());
  }

  @Override
  public void action()
  {
      rd.access().store(DataEngine.execute(EOperatorID.PLUS, DataEngine.execute(EOperatorID.PLUS, CIA.access().load(), DataEngine.valueOf(WORD, 0x4)), DataEngine.valueOf(WORD, 0x4)));
      BRANCH.access().store(DataEngine.valueOf(Type.INT(0x1), 1));
      JMPADDR.access().store(rs.access().load());
  }
}
