/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'minimips.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.instruction.IOperation;
import ru.ispras.microtesk.model.api.instruction.Operation;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.IAddressingMode;
import ru.ispras.microtesk.model.minimips.mode.*;

import static ru.ispras.microtesk.model.minimips.shared.Shared.*;

public final class jr extends Operation {
  private static final class Info extends InfoAndRule {
    Info()
    {
        super(
           jr.class,
           "jr",
           false,
           new ParamDecls()
               .declareParam("addr", ArgumentMode.IN, REG.INFO),
           new Shortcuts()
               .addShortcut(new Info_instruction(), "#root")
        );
    }

    @Override
    public IOperation create(Map<String, Object> args)
    {
        final IAddressingMode addr = (IAddressingMode) getArgument("addr", args);

        return new jr(addr);
    }
  }

  private static final class Info_instruction extends InfoAndRule {
    Info_instruction()
    {
        super(
            instruction.class,
            "jr",
            true,
            new ParamDecls()
                .declareParam("addr", ArgumentMode.IN, REG.INFO)
        );
    }

    @Override
    public IOperation create(Map<String, Object> args)
    {
        final IAddressingMode addr = (IAddressingMode) getArgument("addr", args);

        return new instruction(
            new jr(
                addr
            )
        );
    }
  }

  public static final IInfo INFO = new Info();

  private final IAddressingMode addr;

  public jr(IAddressingMode addr)
  {
      assert REG.INFO.isSupported(addr);

      this.addr = addr;
  }

  @Override
  public String syntax()
  {
      return String.format("jr %s", addr.syntax());
  }

  @Override
  public String image()
  {
      return String.format("000000%s000000000000000000000", addr.image());
  }

  @Override
  public void action()
  {
      BRANCH.access().store(DataEngine.valueOf(Type.INT(0x1), 1));
      JMPADDR.access().store(addr.access().load());
  }
}
