/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'minimips.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.instruction.IOperation;
import ru.ispras.microtesk.model.api.instruction.Operation;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.IAddressingMode;
import ru.ispras.microtesk.model.minimips.mode.*;

import static ru.ispras.microtesk.model.minimips.shared.Shared.*;

public final class mfc0 extends Operation {
  private static final class Info extends InfoAndRule {
    Info()
    {
        super(
           mfc0.class,
           "mfc0",
           false,
           new ParamDecls()
               .declareParam("rt", ArgumentMode.OUT, REG.INFO)
               .declareParam("cs", ArgumentMode.IN, COP0.INFO),
           new Shortcuts()
               .addShortcut(new Info_instruction(), "#root")
        );
    }

    @Override
    public IOperation create(Map<String, Object> args)
    {
        final IAddressingMode rt = (IAddressingMode) getArgument("rt", args);
        final IAddressingMode cs = (IAddressingMode) getArgument("cs", args);

        return new mfc0(rt, cs);
    }
  }

  private static final class Info_instruction extends InfoAndRule {
    Info_instruction()
    {
        super(
            instruction.class,
            "mfc0",
            true,
            new ParamDecls()
                .declareParam("rt", ArgumentMode.OUT, REG.INFO)
                .declareParam("cs", ArgumentMode.IN, COP0.INFO)
        );
    }

    @Override
    public IOperation create(Map<String, Object> args)
    {
        final IAddressingMode rt = (IAddressingMode) getArgument("rt", args);
        final IAddressingMode cs = (IAddressingMode) getArgument("cs", args);

        return new instruction(
            new mfc0(
                rt,
                cs
            )
        );
    }
  }

  public static final IInfo INFO = new Info();

  private final IAddressingMode rt;
  private final IAddressingMode cs;

  public mfc0(IAddressingMode rt, IAddressingMode cs)
  {
      assert REG.INFO.isSupported(rt);
      assert COP0.INFO.isSupported(cs);

      this.rt = rt;
      this.cs = cs;
  }

  @Override
  public String syntax()
  {
      return String.format("mfc0 %s, %s", rt.syntax(), cs.syntax());
  }

  @Override
  public String image()
  {
      return String.format("01000000000%s%s00000000000", rt.image(), cs.image());
  }

  @Override
  public void action()
  {
      rt.access().store(cs.access().load());
  }
}
