/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'minimips.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.instruction.IOperation;
import ru.ispras.microtesk.model.api.instruction.Operation;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.IAddressingMode;
import ru.ispras.microtesk.model.minimips.mode.*;

import static ru.ispras.microtesk.model.minimips.shared.Shared.*;

public final class mult extends Operation {
  private static final class Info extends InfoAndRule {
    Info()
    {
        super(
           mult.class,
           "mult",
           false,
           new ParamDecls()
               .declareParam("rs", ArgumentMode.IN, REG.INFO)
               .declareParam("rt", ArgumentMode.IN, REG.INFO),
           new Shortcuts()
               .addShortcut(new Info_instruction(), "#root")
        );
    }

    @Override
    public IOperation create(Map<String, Object> args)
    {
        final IAddressingMode rs = (IAddressingMode) getArgument("rs", args);
        final IAddressingMode rt = (IAddressingMode) getArgument("rt", args);

        return new mult(rs, rt);
    }
  }

  private static final class Info_instruction extends InfoAndRule {
    Info_instruction()
    {
        super(
            instruction.class,
            "mult",
            true,
            new ParamDecls()
                .declareParam("rs", ArgumentMode.IN, REG.INFO)
                .declareParam("rt", ArgumentMode.IN, REG.INFO)
        );
    }

    @Override
    public IOperation create(Map<String, Object> args)
    {
        final IAddressingMode rs = (IAddressingMode) getArgument("rs", args);
        final IAddressingMode rt = (IAddressingMode) getArgument("rt", args);

        return new instruction(
            new mult(
                rs,
                rt
            )
        );
    }
  }

  public static final IInfo INFO = new Info();

  private final IAddressingMode rs;
  private final IAddressingMode rt;

  public mult(IAddressingMode rs, IAddressingMode rt)
  {
      assert REG.INFO.isSupported(rs);
      assert REG.INFO.isSupported(rt);

      this.rs = rs;
      this.rt = rt;
  }

  @Override
  public String syntax()
  {
      return String.format("mult %s, %s", rs.syntax(), rt.syntax());
  }

  @Override
  public String image()
  {
      return String.format("000000%s%s0000000000011000", rs.image(), rt.image());
  }

  @Override
  public void action()
  {
      mult_result.access().store(DataEngine.execute(EOperatorID.MUL, DataEngine.coerce(Type.INT(0x40), rs.access().load()), DataEngine.coerce(Type.INT(0x40), rt.access().load())));
      HI.access(0x0).store(mult_result.access().bitField(0x3f, 0x20).load());
      LO.access(0x0).store(mult_result.access().bitField(0x1f, 0x0).load());
  }
}
