/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'minimips.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.instruction.IOperation;
import ru.ispras.microtesk.model.api.instruction.Operation;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.IAddressingMode;
import ru.ispras.microtesk.model.minimips.mode.*;

import static ru.ispras.microtesk.model.minimips.shared.Shared.*;

public final class srlv extends Operation {
  private static final class Info extends InfoAndRule {
    Info()
    {
        super(
           srlv.class,
           "srlv",
           false,
           new ParamDecls()
               .declareParam("rd", ArgumentMode.OUT, REG.INFO)
               .declareParam("rt", ArgumentMode.IN, REG.INFO)
               .declareParam("rs", ArgumentMode.IN, REG.INFO),
           new Shortcuts()
               .addShortcut(new Info_instruction(), "#root")
        );
    }

    @Override
    public IOperation create(Map<String, Object> args)
    {
        final IAddressingMode rd = (IAddressingMode) getArgument("rd", args);
        final IAddressingMode rt = (IAddressingMode) getArgument("rt", args);
        final IAddressingMode rs = (IAddressingMode) getArgument("rs", args);

        return new srlv(rd, rt, rs);
    }
  }

  private static final class Info_instruction extends InfoAndRule {
    Info_instruction()
    {
        super(
            instruction.class,
            "srlv",
            true,
            new ParamDecls()
                .declareParam("rd", ArgumentMode.OUT, REG.INFO)
                .declareParam("rt", ArgumentMode.IN, REG.INFO)
                .declareParam("rs", ArgumentMode.IN, REG.INFO)
        );
    }

    @Override
    public IOperation create(Map<String, Object> args)
    {
        final IAddressingMode rd = (IAddressingMode) getArgument("rd", args);
        final IAddressingMode rt = (IAddressingMode) getArgument("rt", args);
        final IAddressingMode rs = (IAddressingMode) getArgument("rs", args);

        return new instruction(
            new srlv(
                rd,
                rt,
                rs
            )
        );
    }
  }

  public static final IInfo INFO = new Info();

  private final IAddressingMode rd;
  private final IAddressingMode rt;
  private final IAddressingMode rs;

  public srlv(IAddressingMode rd, IAddressingMode rt, IAddressingMode rs)
  {
      assert REG.INFO.isSupported(rd);
      assert REG.INFO.isSupported(rt);
      assert REG.INFO.isSupported(rs);

      this.rd = rd;
      this.rt = rt;
      this.rs = rs;
  }

  @Override
  public String syntax()
  {
      return String.format("srlv %s, %s, %s", rd.syntax(), rt.syntax(), rs.syntax());
  }

  @Override
  public String image()
  {
      return String.format("00000000000%s%s%s000110", rs.image(), rt.image(), rd.image());
  }

  @Override
  public void action()
  {
      rd.access().store(DataEngine.execute(EOperatorID.R_SHIFT, DataEngine.coerce(Type.CARD(0x20), rt.access().load()), DataEngine.coerce(Type.CARD(0x20), rs.access().bitField(0x4, 0x0).load())));
  }
}
