/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'minimips.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.instruction.IOperation;
import ru.ispras.microtesk.model.api.instruction.Operation;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.IAddressingMode;
import ru.ispras.microtesk.model.minimips.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.minimips.shared.Shared.*;

public final class xori extends Operation {
  private static final class Info extends InfoAndRule {
    Info()
    {
        super(
           xori.class,
           "xori",
           false,
           new ParamDecls()
               .declareParam("rt", ArgumentMode.OUT, REG.INFO)
               .declareParam("rs", ArgumentMode.IN, REG.INFO)
               .declareParam("imm", SHORT),
           new Shortcuts()
               .addShortcut(new Info_instruction(), "#root")
        );
    }

    @Override
    public IOperation create(Map<String, Object> args)
    {
        final IAddressingMode rt = (IAddressingMode) getArgument("rt", args);
        final IAddressingMode rs = (IAddressingMode) getArgument("rs", args);
        final Location imm = (Location) getArgument("imm", args);

        return new xori(rt, rs, imm);
    }
  }

  private static final class Info_instruction extends InfoAndRule {
    Info_instruction()
    {
        super(
            instruction.class,
            "xori",
            true,
            new ParamDecls()
                .declareParam("rt", ArgumentMode.OUT, REG.INFO)
                .declareParam("rs", ArgumentMode.IN, REG.INFO)
                .declareParam("imm", SHORT)
        );
    }

    @Override
    public IOperation create(Map<String, Object> args)
    {
        final IAddressingMode rt = (IAddressingMode) getArgument("rt", args);
        final IAddressingMode rs = (IAddressingMode) getArgument("rs", args);
        final Location imm = (Location) getArgument("imm", args);

        return new instruction(
            new xori(
                rt,
                rs,
                imm
            )
        );
    }
  }

  public static final IInfo INFO = new Info();

  private final IAddressingMode rt;
  private final IAddressingMode rs;
  private final Location imm;

  public xori(IAddressingMode rt, IAddressingMode rs, Location imm)
  {
      assert REG.INFO.isSupported(rt);
      assert REG.INFO.isSupported(rs);
      assert SHORT.equals(imm.getType());

      this.rt = rt;
      this.rs = rs;
      this.imm = imm;
  }

  @Override
  public String syntax()
  {
      return String.format("xori %s, %s, 0x%x", rt.syntax(), rs.syntax(), imm.load().getRawData().intValue());
  }

  @Override
  public String image()
  {
      return String.format("001110%s%s%s", rs.image(), rt.image(), imm.load().getRawData().toString());
  }

  @Override
  public void action()
  {
      rt.access().store(DataEngine.execute(EOperatorID.BIT_XOR, rs.access().load(), DataEngine.coerce(WORD, imm.load())));
  }
}
