/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'vliw.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.instruction.IOperation;
import ru.ispras.microtesk.model.api.instruction.Operation;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.IAddressingMode;
import ru.ispras.microtesk.model.vliw.mode.*;

import static ru.ispras.microtesk.model.vliw.shared.Shared.*;

public final class MOVE extends Operation {
  private static final class Info extends InfoAndRule {
    Info()
    {
        super(
           MOVE.class,
           "MOVE",
           false,
           new ParamDecls()
               .declareParam("rd", ArgumentMode.OUT, R.INFO)
               .declareParam("rs", ArgumentMode.IN, R.INFO));
    }

    @Override
    public IOperation create(Map<String, Object> args)
    {
        final IAddressingMode rd = (IAddressingMode) getArgument("rd", args);
        final IAddressingMode rs = (IAddressingMode) getArgument("rs", args);

        return new MOVE(rd, rs);
    }
  }

  public static final IInfo INFO = new Info();

  private final IAddressingMode rd;
  private final IAddressingMode rs;

  public MOVE(IAddressingMode rd, IAddressingMode rs)
  {
      assert R.INFO.isSupported(rd);
      assert R.INFO.isSupported(rs);

      this.rd = rd;
      this.rs = rs;
  }

  @Override
  public String syntax()
  {
      return String.format("MOVE %s, %s", rd.syntax(), rs.syntax());
  }

  @Override
  public String image()
  {
      return String.format("000000%s00000%s00000100001", rd.image(), rs.image());
  }

  @Override
  public void action()
  {
      rd.access().store(rs.access().load());
  }
}
