/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'vliw.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.instruction.IOperation;
import ru.ispras.microtesk.model.api.instruction.Operation;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.IAddressingMode;
import ru.ispras.microtesk.model.vliw.mode.*;

import static ru.ispras.microtesk.model.vliw.shared.Shared.*;

public final class MOV_S extends Operation {
  private static final class Info extends InfoAndRule {
    Info()
    {
        super(
           MOV_S.class,
           "MOV_S",
           false,
           new ParamDecls()
               .declareParam("fd", ArgumentMode.OUT, F.INFO)
               .declareParam("fs", ArgumentMode.IN, F.INFO));
    }

    @Override
    public IOperation create(Map<String, Object> args)
    {
        final IAddressingMode fd = (IAddressingMode) getArgument("fd", args);
        final IAddressingMode fs = (IAddressingMode) getArgument("fs", args);

        return new MOV_S(fd, fs);
    }
  }

  public static final IInfo INFO = new Info();

  private final IAddressingMode fd;
  private final IAddressingMode fs;

  public MOV_S(IAddressingMode fd, IAddressingMode fs)
  {
      assert F.INFO.isSupported(fd);
      assert F.INFO.isSupported(fs);

      this.fd = fd;
      this.fs = fs;
  }

  @Override
  public String syntax()
  {
      return String.format("MOV_S %s, %s", fd.syntax(), fs.syntax());
  }

  @Override
  public String image()
  {
      return String.format("0100011000000000%s%s000110", fs.image(), fd.image());
  }

  @Override
  public void action()
  {
      fd.access().store(fs.access().load());
  }
}
