/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'vliw.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.instruction.IOperation;
import ru.ispras.microtesk.model.api.instruction.Operation;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.IAddressingMode;
import ru.ispras.microtesk.model.vliw.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.vliw.shared.Shared.*;

public final class SLL extends Operation {
  private static final class Info extends InfoAndRule {
    Info()
    {
        super(
           SLL.class,
           "SLL",
           false,
           new ParamDecls()
               .declareParam("rd", ArgumentMode.OUT, R.INFO)
               .declareParam("rt", ArgumentMode.IN, R.INFO)
               .declareParam("sa", INDEX));
    }

    @Override
    public IOperation create(Map<String, Object> args)
    {
        final IAddressingMode rd = (IAddressingMode) getArgument("rd", args);
        final IAddressingMode rt = (IAddressingMode) getArgument("rt", args);
        final Location sa = (Location) getArgument("sa", args);

        return new SLL(rd, rt, sa);
    }
  }

  public static final IInfo INFO = new Info();

  private final IAddressingMode rd;
  private final IAddressingMode rt;
  private final Location sa;

  public SLL(IAddressingMode rd, IAddressingMode rt, Location sa)
  {
      assert R.INFO.isSupported(rd);
      assert R.INFO.isSupported(rt);
      assert INDEX.equals(sa.getType());

      this.rd = rd;
      this.rt = rt;
      this.sa = sa;
  }

  @Override
  public String syntax()
  {
      return String.format("SLL %s, %s, %d", rd.syntax(), rt.syntax(), sa.load().getRawData().intValue());
  }

  @Override
  public String image()
  {
      return String.format("00000000000%s%s%s000000", rt.image(), rd.image(), sa.load().getRawData().toString());
  }

  @Override
  public void action()
  {
      rd.access().store(DataEngine.execute(EOperatorID.L_SHIFT, rt.access().load(), DataEngine.coerce(LONG, sa.load())));
  }
}
