/*
 * Copyright 2012-2014 ISP RAS (http://www.ispras.ru)
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */

lexer grammar SimnMLLexer;

options {
  language=Java;
}

import CommonLexer;

@header {
/*
 * Copyright 2012-2015 ISP RAS (http://www.ispras.ru)
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 *
 * WARNING: THIS FILE IS AUTOMATICALLY GENERATED. PLEASE DO NOT MODIFY IT.
 */

package ru.ispras.microtesk.translator.nml.grammar;

import ru.ispras.microtesk.translator.antlrex.TokenSourceIncluder;
}

@members {
private TokenSourceIncluder includer;

public SimnMLLexer(CharStream chars, TokenSourceIncluder includer) {
  this(chars);
  this.includer = includer;
}}

//==================================================================================================
// Preprocessor Directives
//==================================================================================================

PP_INCLUDE : 'include' WHITESPACE '"' filename=PP_FILENAME '"' (WHITESPACE)? NEWLINE {
includer.includeTokensFrom($filename.getText());
skip();
};

fragment
PP_FILENAME : (~('"' | '\n'))*;

//==================================================================================================
// Keywords
//==================================================================================================

/* Declaration Keywords */
LET                     :    'let';
TYPE                    :    'type';
MEM                     :    'mem';
REG                     :    'reg';
VAR                     :    'var';
ALIAS                   :    'alias';
MODE                    :    'mode';
OP                      :    'op';

/* Standard Attributes */
SYNTAX                  :    'syntax';
IMAGE                   :    'image';
ACTION                  :    'action';

/* Data Types */
BOOL                    :    'bool';
CARD                    :    'card';
FIX                     :    'fix';
FLOAT                   :    'float';
INT                     :    'int';
ENUM                    :    'enum';

/* Special Functions */
COERCE                  :    'coerce';
FORMAT                  :    'format';
EXCEPTION               :    'exception';
TRACE                   :    'trace';

/* Control Statements */
IF                      :    'if';
THEN                    :    'then';
ELSE                    :    'else';
ELSEIF                  :    'elif';
ENDIF                   :    'endif';

//==================================================================================================
// The End
//==================================================================================================
